/* Testcase Kernel Installer        */ 
/* written by Taki, 2001 */
/* This software is PUBLIC DOMAIN   */

/*   New in Version 0.5:

   - Removed some bugs...
   - Now all backups go in to a dierectory
   - Prepared for backup fuction in future
   - Added some new bugs ;-)
*/

version="0.5"
'@ECHO OFF'
CALL RxFuncAdd "SYSLoadFuncs","RexxUtil","SYSLoadFuncs"
CALL SYSLoadFuncs

/* Find some informations out */

pwd=DIRECTORY()                /* directory where we are */
my_drive=FILESPEC(D,pwd)       /* drive where we are */
boot_drv=SysBootDrive()        /* find the bootdrive out */
PARSE ARG kernelfile           /* parse the arguments */
IF kernelfile="" THEN
   DO
   SAY 'Error: Kernelfile missing. Please try ''inst-krnl.cmd xxxx.zip'' '
   SAY 'or drop ''xxxx.zip'' on ''inst-krnl.cmd'' (xxxx.zip ist the zipped' 
   SAY 'kernel file from testcase).'
   EXIT 1 /* Exit with error */
   END
file_name=FILESPEC(N,kernelfile)
space=" "
kernel=TRANSLATE(file_name,space,".")
PARSE VAR kernel kernelversion ext
extension=TRANSLATE(ext)
/* check the extension */
IF extension <>"ZIP" THEN
  DO
    SAY 'Error: Kernelfile missing. The argument was not a zip file.'
    EXIT 1 /* Exit with error */
  END

SAY 'Trying to install the testcase kernel 'kernelversion'.'
/* now find out if this kernel was installed before! */

CALL sysfiletree boot_drv'\testcase.txt',testcase_exists
IF testcase_exists.0=0 THEN 
   DO
     rc=STREAM(boot_drv'\testcase.txt','C','OPEN')
     CALL LINEOUT boot_drv'\testcase.txt',kernelversion
     rc=STREAM(boot_drv'\testcase.txt','C','CLOSE')
     'ATTRIB -h 'boot_drv'\testcase.txt' 
     SAY 'Shall I realy install? Press any key to continue or ctrl-c to stop!'
     PAUSE
     CALL do_the_work
     EXIT /* all done and out */
   END
   ELSE DO
      rc=STREAM(boot_drv'\testcase.txt','C','OPEN')
      old_kernelversion=LINEIN(boot_drv'\testcase.txt')
      rc=STREAM(boot_drv'\testcase.txt','C','CLOSE')
      IF old_kernelversion==kernelversion THEN
        DO

           SAY 'This version of the kernel seams to be already installed!'
           SAY 'Shall I realy install? Press any key to continue or ctrl-c to stop!'
           SAY '(Be carefull, your kernel backup will be corrupted!!)'
           PAUSE
           CALL do_the_work
           EXIT 
        END
      ELSE DO
           SAY 'I found a backup made for kernel version 'old_kernelversion'.'
           SAY 'Shall I realy install? Press any key to continue or ctrl-c to stop!'
           PAUSE
           rc=STREAM(boot_drv'\testcase.txt','C','OPEN')
           CALL LINEOUT boot_drv'\testcase.txt',kernelversion
           rc=STREAM(boot_drv'\testcase.txt','C','CLOSE')
           CALL do_the_work
           EXIT /* all done and out */
        END 
   END

EXIT /* Exit the main routine */


do_the_work:
  '@ECHO OFF'
  'COPY' kernelfile boot_drv'\ >nul'
  boot_drv
  'CD 'boot_drv'\'
  CALL sysfiletree boot_drv'\Testcase_Backup',Testcase_Backup_exists
    IF Testcase_Backup_exists.0=0 THEN 
     DO
     'MKDIR Testcase_Backup'
     end /* do */
  'ATTRIB -r -s -h os2krnl'
  'ATTRIB -r -s -h os2ldr'
  'ATTRIB -r -s -h os2krnl.sym'
   say ' ... working ...'
  'COPY os2krnl Testcase_Backup\os2krnl.backup_for_'kernelversion ' >nul'
  'COPY os2ldr Testcase_Backup\os2ldr.backup_for_'kernelversion ' >nul'
  'COPY os2krnl.sym Testcase_Backup\os2krnl.sym.backup_for_'kernelversion ' >nul'
  'MKDIR Testcase_Backup\trace_backup_for_'kernelversion ' >nul'
  'COPY d:\os2\system\trace\*.tdf  Testcase_Backup\trace_backup_for_'kernelversion ' >nul'
  'unzip.exe -o 'kernelfile ' >nul'
  'ATTRIB +r +s +h 'boot_drv'\os2krnl'
  'ATTRIB +r +s +h 'boot_drv'\os2ldr'
  'ATTRIB +r +s +h 'boot_drv'\os2krnl.sym' ' >nul'
  'del ' boot_drv'\'kernelversion'.zip'
  my_drive
  'cd' pwd
  SAY 'Done!'
  SAY 'You ''ll find the saved original files in:'
  SAY  boot_drv'\Testcase_Backup\*.backup_for_'kernelversion' and'
  SAY  boot_drv'\Testcase_Backup\trace_backup_for_'kernelversion
RETURN


EXIT

